def get_odd_count(n: list) -> int:
    """Get the amount of odd rows in a matrix"""

    return len([x for x in [sum(n) for n in a] if x % 2 == 1])


def find_problematic_rows(n: list) -> list[int]:
    """Find even rows in a list and return their indexes"""

    for i, row in enumerate(n):
        if sum(row) % 2 == 0:
            yield i


n, m = map(int, input().split())
c = list(map(int, input().split()))
a = [[0 for i in range(m)] for i in range(n)]


columns = sorted(list(map(list, enumerate(c))), key=lambda x: x[1], reverse=True)
for col in columns:
    problems = find_problematic_rows(a)

    # fill in problematic rows first
    for problem in problems:
        if col[1] == 0:
            break
        a[problem][col[0]] = 1
        col[1] -= 1

    # fill in the rest if needed (column still has power left)
    for row in a:
        if col[1] == 0:
            break
        if row[col[0]] != 1:
            row[col[0]] = 1
            col[1] -= 1


print(get_odd_count(a))
for i in range(0, n):
    for j in range(0, m):
        print(a[i][j], end=" ")
    print('\n', end='')