n = int(input())
if n == 0:
    print(0)
    exit()

moves = []

# Initialize the columns. Each column i (0-based) has (n-i) cubes of (i+1)
columns = []
for i in range(n):
    col = [i+1] * (n - i)
    columns.append(col)

# Process each target column from right to left (i from n-1 to 0)
for target_col in range(n-1, -1, -1):
    # The target column should have values [1, 2, ..., target_col+1] from bottom to top
    # So we need to place (target_col+1) values starting from 1 up to target_col+1
    for required in range(1, target_col + 2):
        # Check if the current position in the target_col has the required value
        # The position is (required - 1) from the bottom, which is index (len(columns[target_col]) - (required))
        current_len = len(columns[target_col])
        pos_from_bottom = required
        pos_index = current_len - pos_from_bottom
        
        if pos_index >= 0 and columns[target_col][pos_index] == required:
            continue  # Already in place
        
        # Need to get 'required' into this position
        # First, move all cubes above this position to a temporary column (target_col -1)
        # If target_col is 0, use a different temp (like n-1), but assuming target_col starts from right
        temp_col = target_col - 1
        if temp_col < 0:
            temp_col = n - 1  # just in case, though for target_col=0, required is 1, and it's already the first column
        
        # Move cubes from the current target_col above the position to temp_col
        while len(columns[target_col]) > pos_from_bottom - 1:
            cube = columns[target_col].pop()
            moves.append((target_col + 1, temp_col + 1))
            columns[temp_col].append(cube)
        
        # Now, get the 'required' cube from its original column (required-1)
        source_col = required - 1
        # Find the 'required' cube in the source_col
        # To access it, we need to remove cubes on top of it
        # So find the index of 'required' in source_col
        # Since source_col initially has (n - (required-1)) cubes of 'required'
        # But after previous moves, it might have other cubes on top
        # So we need to move all cubes above the 'required' in source_col to a temp (target_col)
        required_pos = -1
        for idx in reversed(range(len(columns[source_col]))):
            if columns[source_col][idx] == required:
                required_pos = idx
                break
        
        if required_pos == -1:
            # This should not happen as per problem statement
            continue
        
        # Move cubes above required in source_col to target_col (which is now empty)
        while len(columns[source_col]) > required_pos + 1:
            cube = columns[source_col].pop()
            moves.append((source_col + 1, target_col + 1))
            columns[target_col].append(cube)
        
        # Now, take the 'required' cube
        cube = columns[source_col].pop()
        moves.append((source_col + 1, target_col + 1))
        columns[target_col].append(cube)
        
        # Move back the cubes from target_col to source_col
        while len(columns[target_col]) > 0 and columns[target_col][-1] != cube:
            cube_moved = columns[target_col].pop()
            moves.append((target_col + 1, source_col + 1))
            columns[source_col].append(cube_moved)
        
        # Now, move back the cubes from temp_col to target_col
        while len(columns[temp_col]) > 0 and (columns[temp_col][-1] != required or len(columns[target_col]) < pos_from_bottom):
            cube = columns[temp_col].pop()
            moves.append((temp_col + 1, target_col + 1))
            columns[target_col].append(cube)

print(len(moves))
for a, b in moves:
    print(a, b)