def minimum_moves_to_rearrange(n):
    moves = []
    
    # Create the initial matrix
    matrix = [[0] * n for _ in range(n)]
    
    # Fill the matrix according to the problem statement
    for i in range(n):
        for j in range(n):
            if j < n - i:
                matrix[i][j] = 1  # Fill below the opposite diagonal
            else:
                matrix[i][j] = 0  # Fill above the opposite diagonal

    # Now we need to rearrange the elements
    # We will move elements from the top of one column to the top of another
    for j in range(n):
        for i in range(n):
            if matrix[i][j] == 1:
                # Move this element to the correct position below the opposite diagonal
                for k in range(i + 1, n):
                    if matrix[k][n - 1 - j] == 0:  # Find an empty spot below the opposite diagonal
                        moves.append((i + 1, n - j))  # Record the move (1-based index)
                        matrix[k][n - 1 - j] = 1  # Place the element
                        matrix[i][j] = 0  # Remove the element from the original position
                        break

    # Output the number of moves and the moves themselves
    print(len(moves))
    for move in moves:
        print(move[0], move[1])

# Read input
n = int(input())
minimum_moves_to_rearrange(n)