def minimum_moves_to_rearrange(n):
    moves = []
    
    # Create the initial matrix
    matrix = [[0] * n for _ in range(n)]
    
    # Fill the initial matrix according to the problem statement
    for i in range(n):
        for j in range(n):
            if j <= i:
                matrix[i][j] = n - j  # Fill below the main diagonal
            else:
                matrix[i][j] = 0  # Fill above the main diagonal with 0s

    # Print the initial matrix for reference
    print("Initial Matrix:")
    for row in matrix:
        print(row)

    # Rearranging elements below the opposite diagonal
    for i in range(n):
        for j in range(n):
            if i + j >= n:  # Below the opposite diagonal
                # Move elements to their correct positions
                if matrix[i][j] != 0:
                    # Find the target position
                    target_row = n - 1 - j
                    target_col = i
                    if target_row >= 0 and target_col < n:
                        # Move the element
                        moves.append((i + 1, j + 1, target_row + 1, target_col + 1))  # Store moves in 1-based index
                        # Perform the move in the matrix
                        matrix[target_row][target_col] = matrix[i][j]
                        matrix[i][j] = 0  # Set the original position to 0

    # Output the number of moves and the moves themselves
    print(len(moves))
    for move in moves:
        print(move[0], move[1], move[2], move[3])

# Read input
n = int(input())
minimum_moves_to_rearrange(n)