n, m = map(int, input().split())
c = list(map(int, input().split()))
from itertools import combinations
from typing import List

def maximumRows(matrix, numSelect: int) -> int:
    m, n = len(matrix), len(matrix[0])
    rows = []
    
    # Convert each row to a binary representation
    for row in matrix:
        mask = 0
        for j in range(n):
            if row[j] == 1:
                mask |= (1 << j)
        rows.append(mask)
    
    max_odd_rows = 0
    
    # Generate all combinations of columns to select
    for cols in combinations(range(n), numSelect):
        selected_mask = 0
        for col in cols:
            selected_mask |= (1 << col)
        
        odd_count = 0
        
        # Count how many rows have an odd number of ones
        for row_mask in rows:
            # Count the number of 1s in the row after applying the selected columns
            if bin(row_mask & selected_mask).count('1') % 2 == 1:
                odd_count += 1
        
        max_odd_rows = max(max_odd_rows, odd_count)
    
    return max_odd_rows

matrix = [[1]*c[y]+[0]*(n-c[y]) for y in range(m)]
print(maximumRows(matrix,8)) 