import sys
from collections import defaultdict

def main():
    input = sys.stdin.read
    data = input().split()
    idx = 0
    n = int(data[idx])
    q = int(data[idx + 1])
    idx += 2
    a = list(map(int, data[idx:idx + n]))
    idx += n

    # Зберігаємо останній індекс кожного елемента
    last_index = defaultdict(int)
    # Масив для зберігання останнього індексу кожного елемента
    last_occurrence = [0] * n

    for i in range(n):
        last_occurrence[i] = last_index.get(a[i], -1)
        last_index[a[i]] = i

    # Бінарне індексоване дерево (Fenwick Tree) для підрахунку унікальних елементів
    class FenwickTree:
        def __init__(self, size):
            self.n = size
            self.tree = [0] * (self.n + 2)

        def update(self, idx, delta=1):
            while idx <= self.n:
                self.tree[idx] += delta
                idx += idx & -idx

        def query(self, idx):
            res = 0
            while idx > 0:
                res += self.tree[idx]
                idx -= idx & -idx
            return res

    # Ініціалізація Fenwick Tree
    ft = FenwickTree(n)
    for i in range(n):
        if last_occurrence[i] == -1:
            ft.update(i + 1, 1)  # Індексація з 1

    w = set()  # Використовуємо set для швидкого пошуку

    for _ in range(q):
        type = int(data[idx])
        idx += 1
        if type == 1:
            x = int(data[idx])
            idx += 1
            if x in w:
                w.remove(x)
            else:
                w.add(x)
        elif type == 2:
            l = int(data[idx])
            r = int(data[idx + 1])
            idx += 2
            r = min(r, n)  # Обрізаємо r, якщо він більший за розмір масиву
            # Кількість унікальних елементів у підмасиві [l, r]
            unique_count = ft.query(r) - ft.query(l - 1)
            print(unique_count)
            # Віднімаємо елементи, які є в w
            result = unique_count
            for x in w:
                if l <= last_index.get(x, -1) + 1 <= r:
                    result -= 1
            print(result)
        elif type == 3:
            x = int(data[idx])
            t = int(data[idx + 1])
            idx += 2
            # Оновлюємо масив a
            a[x - 1] = t
            # Оновлюємо останній індекс для старого елемента
            old_value = a[x - 1]
            if last_index.get(old_value, -1) == x - 1:
                last_index[old_value] = -1
                ft.update(x, -1)
            # Оновлюємо останній індекс для нового елемента
            last_index[t] = x - 1
            ft.update(x, 1)

if __name__ == "__main__":
    main()