#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>

using namespace std;
using ll = long long;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int height, width;
    cin >> height >> width;

    vector<int> row_sums(height, 0);
    vector<int> col_sums(width);

    for (int i = 0; i < width; i++) {
        cin >> col_sums[i];
    }

    vector<vector<int>> matrix(height, vector<int>(width, 0));

    vector<int> min_zeros(width);
    vector<int> max_zeros(width);

    min_zeros[0] = height - col_sums[0];
    max_zeros[0] = height - col_sums[0];
    // cout << min_zeros[0] << " " << max_zeros[0] << "\n";

    for (int j = 1; j < width; j++) {
        int prev_min = min_zeros[j - 1];
        int prev_max = max_zeros[j - 1];
        int col = col_sums[j];

        if (col <= prev_min) {
            min_zeros[j] = prev_min - col;
        } else if (col >= prev_max) {
            min_zeros[j] = col - prev_max;
        } else {
            min_zeros[j] = col % 2 != prev_max % 2;
        }

        if (col <= height - prev_max) {
            max_zeros[j] = prev_max + col;
        } else if (col >= height - prev_min) {
            max_zeros[j] = height * 2 - col - prev_min;
        } else {
            max_zeros[j] = height - (col % 2 != (height - prev_max) % 2);
        }

        // cout << min_zeros[j] << " " << max_zeros[j] << "\n";
    }

    /*
    vector<int> needed_zeros(width);
    needed_zeros[width - 1] = min_zeros[width - 1];

    for (int j = width - 2; j >= 0; j--) {
        a zeros
        b shift
        c col sum
        r result zeros

        h-a ones
        o = max(c + (h-a) - (h-b), 0) = max(c-a+b, 0) overlaps
        r1 = c + (h-a) - 2o result ones
        r = h-r1 = h-c-h+a+2o = a-c+2o result zeros

        r + c = a + 2o = a + 2max(c-a+b, 0)

        <=0:
        c - a + b <= 0
        a = r + c
        c - r - c + b <= 0
        b - r <= 0
        r >= b

        >=0:
        c - a + b >= 0
        a + 2c - 2a + 2b = r + c
        c - a + 2b = r
        a = c + 2b - r
        c - c - 2b + r + b >= 0
        r >= b

        int opt1 = needed_zeros[j + 1] + col_sums[j];
        int opt2 = col_sums[j] - needed_zeros[j + 1];

        cout << opt1 << " " << opt2 << "\n";

        if (min_zeros[j] <= opt1 && opt1 <= max_zeros[j] && opt1 % 2 == max_zeros[j] % 2) {
            needed_zeros[j] = opt1;
            continue;
        }

        needed_zeros[j] = opt2;
    }

    for (int j = 0; j < width; j++) {
        cout << needed_zeros[j] << " ";
    }

    cout << "\n";
    */

    deque<int> zero_pos{};
    deque<int> one_pos{};

    for (int i = 0; i < min_zeros[width - 1]; i++) {
        zero_pos.push_back(i);
    }

    for (int i = min_zeros[width - 1]; i < height; i++) {
        one_pos.push_back(i);
    }

    for (int j = width - 1; j >= 0; j--) {
        int avail_ones = col_sums[j];
        int target_min = j > 0 ? min_zeros[j - 1] : height;
        int target_max = j > 0 ? max_zeros[j - 1] : height;

        int can_pop_zeros = zero_pos.size();
        int can_pop_ones = one_pos.size();

        // cout << j << " " << zero_pos.size() << " " << target_min << " " << target_max << "\n";

        while (zero_pos.size() > target_max) {
            // cout << "a\n";
            one_pos.push_back(zero_pos.front());
            matrix[zero_pos.front()][j] = 1;
            zero_pos.pop_front();
            avail_ones -= 1;
            can_pop_zeros -= 1;
        }

        while (zero_pos.size() < target_min) {
            // cout << "b\n";
            zero_pos.push_back(one_pos.front());
            matrix[one_pos.front()][j] = 1;
            one_pos.pop_front();
            avail_ones -= 1;
            can_pop_ones -= 1;
        }

        // cout << avail_ones << " " << can_pop_zeros << " " << can_pop_ones << "\n";

        if (avail_ones % 2 == 1) {
            if (zero_pos.size() == target_min) {
                // cout << "c\n";
                zero_pos.push_back(one_pos.front());
                matrix[one_pos.front()][j] = 1;
                one_pos.pop_front();
                avail_ones -= 1;
                can_pop_ones -= 1;
            } else {
                // cout << "d\n";
                one_pos.push_back(zero_pos.front());
                matrix[zero_pos.front()][j] = 1;
                zero_pos.pop_front();
                avail_ones -= 1;
                can_pop_zeros -= 1;
            }
        }

        while (avail_ones > 0 && can_pop_ones > 0 && can_pop_zeros > 0) {
            // cout << "ef\n";
            zero_pos.push_back(one_pos.front());
            matrix[one_pos.front()][j] = 1;
            one_pos.pop_front();
            avail_ones -= 1;
            can_pop_ones -= 1;

            one_pos.push_back(zero_pos.front());
            matrix[zero_pos.front()][j] = 1;
            zero_pos.pop_front();
            avail_ones -= 1;
            can_pop_zeros -= 1;
        }

        while (zero_pos.size() < target_max && avail_ones > 0 && can_pop_ones > 0) {
            // cout << "e\n";
            zero_pos.push_back(one_pos.front());
            matrix[one_pos.front()][j] = 1;
            one_pos.pop_front();
            avail_ones -= 1;
            can_pop_ones -= 1;
        }

        while (zero_pos.size() > target_min && avail_ones > 0 && can_pop_zeros > 0) {
            // cout << "f\n";
            one_pos.push_back(zero_pos.front());
            matrix[zero_pos.front()][j] = 1;
            zero_pos.pop_front();
            avail_ones -= 1;
            can_pop_zeros -= 1;
        }

        /*
        for (int k = 0; k < avail_ones; k += 2) {
            one_pos.push_back(zero_pos.front());
            zero_pos.push_back(one_pos.front());
            matrix[zero_pos.front()][j] = 1;
            matrix[one_pos.front()][j] = 1;
            cout << "e " << one_pos.front() << " " << zero_pos.front() << "\n";
            one_pos.pop_front();
            zero_pos.pop_front();
        }
        */
    }

    cout << (height - min_zeros[width - 1]) << "\n";

    for (int i = 0; i < height; i++) {
        for (int j = 0; j < width; j++) {
            cout << matrix[i][j] << " ";
        }

        cout << "\n";
    }

    /*
    1 0 1 1
    1 1 1 0
    0 0 1 0
    0 0 1 0
    1 0 1 0
    1 0 1 0
    1 0 0 0
    1 0 0 0

    1:
    min # of overlaps = 0
    min odd = c1
    max odd = c1

    2:
    min # of overlaps = max(0, c1 + c2 - n)
    min odd = |c1 - c2|
    max odd = c1 + c2 - 2 * (min # of overlaps)
    */

    return 0;
}
