#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

using namespace std;
using ll = long long;

void solve1(int n, int q) {
    vector<int> array(n);
    map<bool> off{};

    for (int i = 0; i < n; i++) {
        cin >> array[i];
    }

    for (int i = 0; i < q; i++) {
        int t;
        cin >> t;

        if (t == 1) {
            int x;
            cin >> x;

            off[x] = !off[x];
        } else if (t == 2) {
            int l, r;
            cin >> l >> r;

            set<int> seen{};
            int res = 0;

            for (int j = l - 1; j < r; j++) {
                int val = array[j];

                if (off[val] || seen.find(val) != seen.end()) {
                    continue;
                }

                seen.insert(val);
                res += 1;
            }


            cout << res << "\n";
        } else if (t == 3) {
            int x, v;
            cin >> x >> v;
            array[x] = v;
        }
    }
}

void solve2(int n, int q, vector<int> a, vector<int> r) {
    set<int> seen{};
    int res = 0;

    for (int i = 0; i < n; i++) {
        if (seen.find(a[i]) == seen.end()) {
            seen.insert(a[i]);
            res += 1;
        }

        cout << res << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, q;
    cin >> n >> q;

    solve1(n, q);

    return 0;
}
