#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

using namespace std;
using ll = long long;

void solve1(int n, int q) {
    vector<int> array(n);
    map<int, bool> off{};

    for (int i = 0; i < n; i++) {
        cin >> array[i];
    }

    for (int i = 0; i < q; i++) {
        int t;
        cin >> t;

        if (t == 1) {
            int x;
            cin >> x;

            off[x] = !off[x];
        } else if (t == 2) {
            int l, r;
            cin >> l >> r;

            set<int> seen{};
            int res = 0;

            for (int j = l - 1; j < r; j++) {
                int val = array[j];

                if (off[val] || seen.find(val) != seen.end()) {
                    continue;
                }

                seen.insert(val);
                res += 1;
            }


            cout << res << "\n";
        } else if (t == 3) {
            int x, v;
            cin >> x >> v;
            array[x - 1] = v;
        }
    }
}

void solve2(int n, int q, vector<int> a, vector<int> r) {
    set<int> seen{};
    int res = 0;

    for (int i = 0; i < n; i++) {
        if (seen.find(a[i]) == seen.end()) {
            seen.insert(a[i]);
            res += 1;
        }

        cout << res << "\n";
    }
}

void solve8(int n, int q) {
    vector<set<int>> occurences(107, set<int>{});
    vector<int> off(107, 0);
    vector<int> arr(n);

    for (int i = 0; i < n; i++) {
        cin >> arr[i];

        occurences[arr[i]].insert(i);
    }

    for (int i = 0; i < q; i++) {
        int t;
        cin >> t;

        if (t == 1) {
            int x;
            cin >> x;

            if (x <= 100) {
                off[x] = 1 - off[x];
            }
        } else if (t == 3) {
            int x, v;
            cin >> x >> v;

            x -= 1;

            occurences[arr[x]].erase(x);
            occurences[v].insert(x);
            arr[x] = v;
        } else if (t == 2) {
            int l, r;
            cin >> l >> r;

            l -= 1;

            int res = 0;

            for (int a = 1; a <= 100; a++) {
                if (off[a]) {
                    continue;
                }

                auto iter = upper_bound(occurences[a].begin(), occurences[a].end(), l);

                if (iter != occurences[a].end() && *iter < r) {
                    res += 1;
                }
            }

            cout << res << "\n";
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, q;
    cin >> n >> q;

    if (n <= 1000 && q <= 1000) {
        solve1(n, q);
        retrurn 0;
    }

    solve8(n, q);

    return 0;
}
