#include <bits/stdc++.h>

using namespace std;

struct Fenwick {
    int n;
    vector<int> fen;


    Fenwick(int m) {
        n = m;
        fen.resize(n + 1, 0);
    }

    int pref(int r) {
        int ans = 0;
        while (r > 0) {
            ans += fen[r];
            r -= (r & (-r));
        }
        return ans;
    }

    int query(int l, int r) {
        return pref(r) - pref(l - 1);
    }

    void upd(int i, int del) {
        while (i <= n) {
            fen[i] += del;
            i += (i & (-i));
        }
    }
};


int main()
{
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int n, q;
    cin >> n >> q;

    map<int, bool> w;


    int a[n + 1];
    set<int> s;
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        s.insert(a[i]);
    }

    map<int, int> conv;
    int cur = 0;
    for (int ad : s) {
        conv[ad] = cur++;
    }

    int ind[n + 1] = {};

    for (int i = 1; i <= n; i++) {
        a[i] = conv[a[i]];
        ind[a[i]] = i;
    }

    Fenwick fen = Fenwick(n);

    bool dis[n + 1] = {};

    while (q--) {
        int type;
        cin >> type;

        if (type == 1) {
            int x;
            cin >> x;
            if (conv.count(x) != 0) {
                x = conv[x];
                if (!dis[x]) {
                    fen.upd(ind[x], 1);
                    dis[x] = true;
                }
                else {
                    fen.upd(ind[x], -1);
                    dis[x] = false;
                }
            }
        }
        else {
            int l, r;
            cin >> l >> r;

            int ans = (r - l + 1) - fen.query(l, r);
            printf("%i\n", ans);
        }
    }




}
