#include <iostream>
#include <vector>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <algorithm>
using namespace std;

int main(){
    int n, q;
    cin >> n >> q;
    
    vector<int> a(n);
    for (int i = 0; i < n; i++){
        cin >> a[i];
    }
    
    unordered_map<int, bool> t;
    
    int bs = int(sqrt(n)) + 1;
    int numBlocks = (n + bs - 1) / bs;
    
    vector<unordered_map<int, int>> blocks(numBlocks);
    for (int i = 0; i < n; i++){
        int b = i / bs;
        blocks[b][a[i]]++;
    }
    
    auto toggle = [&](int x){
        bool cur = true;
        if(t.find(x) != t.end()){
            cur = t[x];
        }
        t[x] = !cur;
    };
    
    auto isActive = [&](int x)->bool {
        if(t.find(x) == t.end())
            return true;
        else
            return t[x];
    };
    
    
    auto updatePos = [&](int pos, int newVal){
        int b = pos / bs;
        int oldVal = a[pos];
        
        if(--blocks[b][oldVal] == 0)
            blocks[b].erase(oldVal);
            
        blocks[b][newVal]++;
        a[pos] = newVal;
    };
    
    
    auto que = [&](int l, int r) -> int {
        unordered_set<int> c;
        int sb = l / bs, eb = r / bs;
        
        if(sb == eb){
            
            for (int i = l; i <= r; i++){
                c.insert(a[i]);
            }
        } else {
            
            int ef = (sb+1)*bs - 1;
            for (int i = l; i <= min(r, ef); i++){
                c.insert(a[i]);
            }
            
            for (int b = sb+1; b < eb; b++){
                for (auto &p : blocks[b]){
                    c.insert(p.first);
                }
            }
            
            int sl = eb * bs;
            for (int i = max(sl, l); i <= r; i++){
                c.insert(a[i]);
            }
        }
        
        int cnt = 0;
        for (int num : c){
            if(isActive(num))
                cnt++;
        }
        return cnt;
    };
    
    while(q--){
        int type;
        cin >> type;
        if(type == 1){ 
            int x;
            cin >> x;
            toggle(x);
        }
        else if(type == 2){
            int l, r;
            cin >> l >> r;
            
            cout << que(l-1, r-1) << "\n";
        }
        else if(type == 3){
            
            int pos, t;
            cin >> pos >> t;
            updatePos(pos-1, t);
        }
    }
    
    return 0;
}
