#include <bits/stdc++.h>
using namespace std;

int steps[4096][2];
int stepsMade = 0;

void moveBlock(int columns[][4096], int source, int dest) {
    int capacitySource = columns[source][0];
    int capacityDest = columns[dest][0];
    columns[dest][capacityDest + 1] = columns[source][capacitySource];
    columns[source][0]--;
    columns[dest][0]++;

    steps[stepsMade][0] = source + 1;
    steps[stepsMade][1] = dest + 1;
    stepsMade++;
}

int getBlockAtColumn(int columns[][4096], int source) {
    int capacitySource = columns[source][0];
    return columns[source][capacitySource];
}

void debugprint(int columns[][4096], int siz) {
    for (int i = 0; i<siz; i++) {
        for (int x = 0; x<columns[i][0]; x++) {
            cout << columns[i][x + 1];
        }
        cout << endl;
    }
}

int findColumnForBlock(int columns[][4096], int siz, int desiredBlock, int *operationsNeeded) {
    int closestColumn = -1;
    int operationsMade = 999999;
    for (int i = 0; i<siz; i++) {
        for (int x = columns[i][0]; x>0; x--) {
            //printf("column[%d][%d] = %d, searching for %d\n", i, x, columns[i][x], desiredBlock);
            if (columns[i][x] == desiredBlock && columns[i][0]-x < operationsMade) {
                operationsMade=columns[i][0]-x;
                closestColumn=i;
                break;
            }
        }
    }
    *operationsNeeded = operationsMade;
    return closestColumn;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin>>n;

    // change the upper bound. columns[n][0] is the capacity btw
    int columns[n][4096];
    // generate it
    for (int i=0; i<n; i++) {
        for (int x=0; x<n-i; x++) {
            columns[i][x+1] = i;
        }
        columns[i][0] = n-i;
    }

    //debugprint(columns, n);

    // step 1: move biggest block to make space
    moveBlock(columns, n-1, 2-1);
    // step 2: move 1 into the now empty last column
    moveBlock(columns, 0, n-1);

    // debug
    //debugprint(columns, n);
    for (int i=n-1; i>=0; i--) {
        // build the column
        // first find the last correct block
        //printf("\n --- [ BUILDING COLUMN %d ] ---\n", i + 1);
        int lastCorrectIdx = columns[i][0];
        for (int chkIdx = 1; chkIdx < columns[i][0] + 1; chkIdx++) {
            if (columns[i][chkIdx] != chkIdx - 1) {
                lastCorrectIdx = chkIdx - 1;
                break;
            }
        }
        //printf("last correct block of column %d is located at offset: %d, need to perform moves: %d\n", i+1, lastCorrectIdx, columns[i][0] - lastCorrectIdx);
        // step 1: make way
        int beginNum = lastCorrectIdx == 0 ? 0 : columns[i][lastCorrectIdx] + 1;
        for (int opCount = 0; opCount<columns[i][0] - lastCorrectIdx; opCount++) {
            // find where to move it away:
            // - not ourselves
            // - not a column that contains the first block we'll need
            for (int potentialColumn=0; potentialColumn<n; potentialColumn++) {
                int pcCap = columns[potentialColumn][0];
                if (potentialColumn != i && (pcCap == 0 || columns[potentialColumn][pcCap] != beginNum)) {
                    moveBlock(columns, i, potentialColumn);
                    break;
                }
            }
        }
        //debugprint(columns, n);
        // step 2: find the blocks we need and move em

        for (int num=beginNum; num<i+1; num++) {
            int operationsNeeded;
            int srcColumn = findColumnForBlock(columns, i, num, &operationsNeeded);
            if (srcColumn == -1) {
                // try again with all the columns
                srcColumn = findColumnForBlock(columns, n, num, &operationsNeeded);
            }
            // todo: test if we need to make any operations for it

            if (operationsNeeded != 0) {
                //printf("must make way for %d at column %d by doing %d operations\n", num, srcColumn + 1, operationsNeeded);
                // do not move to:
                //  - the source column itself
                //  - the target column
                //  - in the future, also make it check for potential future blocks
                for (int potentialColumn=0; potentialColumn<n; potentialColumn++) {
                    if (potentialColumn != srcColumn && potentialColumn != i) {
                        moveBlock(columns, srcColumn, potentialColumn);
                        break;
                    }
                }
            }
            moveBlock(columns, srcColumn, i);
        }

    }

    //debugprint(columns, n);
    cout << stepsMade << endl;
    for (int i = 0; i<stepsMade; i++) {
        cout << steps[i][0] << ' ' << steps[i][1] << endl;
    }


    return 0;
}
