#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

using namespace std;

#pragma GCC target("avx2")

#define ll int
#define lf long double
#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()
#define nl "\n"
#define chmyax(a,b) a=max(a,b)
#define chmyin(a,b) a=min(a,b)

#define SZ 300000
#define BLOCK_SIZE 5480

void cpu_wait(ll s){
    auto tm = chrono::system_clock::now();
    while (chrono::duration_cast<chrono::milliseconds>(chrono::system_clock::now()-tm).count()<s){}
}

vector<ll> arr;
vector<bitset<SZ>> vertices;
void add_elem(ll v, ll l, ll r, ll ind, ll val){
    if (l==r){
        vertices[v][val]=1;
        return;
    }
    ll m = (l+r)/2;
    if (ind<=m){
        add_elem(v*2,l,m,ind,val);
    }else {
        add_elem(v*2+1,m+1,r,ind,val);
    }
    vertices[v][val]=1;
}
ll update(ll v, ll l, ll r, ll ind, ll val){
    if (l==r){
        ll deleted = arr[l];
        vertices[v][arr[l]]=0;
        vertices[v][val]=1;
        return deleted;
    }
    ll m = (l+r)/2;
    ll deleted = -1;
    if (ind<=m){
        deleted = update(v*2,l,m,ind,val);
        if (vertices[v*2+1][deleted]){
            deleted=-1;
        }
    }else {
        deleted = update(v*2+1,m+1,r,ind,val);
        if (vertices[v*2][deleted]){
            deleted=-1;
        }
    }
    if (deleted!=-1){
        vertices[v][deleted]=0;
    }
    vertices[v][val]=1;
    return deleted;
}

bitset<SZ> get(ll v, ll l, ll r, ll ql, ll qr){
    if (ql>qr)return {};
    if (l==ql && r==qr){
        return vertices[v];
    }
    ll m = (l+r)/2;
    bitset<SZ> tmp=get(v*2,l,m,ql,min(qr,m));
    tmp |= get(v*2+1,m+1,r,max(m+1,ql),qr);
    return tmp;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n,m;
    ll a,b,c,d,e,f,g,q;
    cin>>n>>q;
    vertices.resize(4*n);
    unordered_map<ll,ll> loc;
    arr.resize(n);
    ll ind=0;
    for (ll i=0;i<n;i++){
            cin>>arr[i];
            loc[arr[i]]=i;
            add_elem(1,0,n-1,i,arr[i]);
    }
    while (q--){
        cin>>a;
        if (a==3){
            cin>>b>>c;
            --b;
            if (arr[b]==c)continue;
            update(1,0,n-1,b,c);
            arr[b]=c;
        }else {
            cin>>b>>c;
            --b;
            --c;
            cout<<get(1,0,n-1,b,c).count()<<nl;
        }
    }
}
